git-rebase--interactive.shon commit t/t8003-blame-corner-cases.sh: Use here documents (c66b470)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# http://article.gmane.org/gmane.comp.version-control.git/22407
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
  97: ${comment_char:=#}
  98
  99warn () {
 100        printf '%s\n' "$*" >&2
 101}
 102
 103# Output the commit message for the specified commit.
 104commit_message () {
 105        git cat-file commit "$1" | sed "1,/^$/d"
 106}
 107
 108orig_reflog_action="$GIT_REFLOG_ACTION"
 109
 110comment_for_reflog () {
 111        case "$orig_reflog_action" in
 112        ''|rebase*)
 113                GIT_REFLOG_ACTION="rebase -i ($1)"
 114                export GIT_REFLOG_ACTION
 115                ;;
 116        esac
 117}
 118
 119last_count=
 120mark_action_done () {
 121        sed -e 1q < "$todo" >> "$done"
 122        sed -e 1d < "$todo" >> "$todo".new
 123        mv -f "$todo".new "$todo"
 124        new_count=$(git stripspace --strip-comments <"$done" | wc -l)
 125        echo $new_count >"$msgnum"
 126        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 127        echo $total >"$end"
 128        if test "$last_count" != "$new_count"
 129        then
 130                last_count=$new_count
 131                printf "Rebasing (%d/%d)\r" $new_count $total
 132                test -z "$verbose" || echo
 133        fi
 134}
 135
 136# Put the last action marked done at the beginning of the todo list
 137# again. If there has not been an action marked done yet, leave the list of
 138# items on the todo list unchanged.
 139reschedule_last_action () {
 140        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 141        sed -e \$d <"$done" >"$done".new
 142        mv -f "$todo".new "$todo"
 143        mv -f "$done".new "$done"
 144}
 145
 146append_todo_help () {
 147        git stripspace --comment-lines >>"$todo" <<\EOF
 148
 149Commands:
 150 p, pick = use commit
 151 r, reword = use commit, but edit the commit message
 152 e, edit = use commit, but stop for amending
 153 s, squash = use commit, but meld into previous commit
 154 f, fixup = like "squash", but discard this commit's log message
 155 x, exec = run command (the rest of the line) using shell
 156 d, drop = remove commit
 157
 158These lines can be re-ordered; they are executed from top to bottom.
 159
 160EOF
 161        if test $(get_missing_commit_check_level) = error
 162        then
 163                git stripspace --comment-lines >>"$todo" <<\EOF
 164Do not remove any line. Use 'drop' explicitly to remove a commit.
 165EOF
 166        else
 167                git stripspace --comment-lines >>"$todo" <<\EOF
 168If you remove a line here THAT COMMIT WILL BE LOST.
 169EOF
 170        fi
 171}
 172
 173make_patch () {
 174        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 175        case "$sha1_and_parents" in
 176        ?*' '?*' '?*)
 177                git diff --cc $sha1_and_parents
 178                ;;
 179        ?*' '?*)
 180                git diff-tree -p "$1^!"
 181                ;;
 182        *)
 183                echo "Root commit"
 184                ;;
 185        esac > "$state_dir"/patch
 186        test -f "$msg" ||
 187                commit_message "$1" > "$msg"
 188        test -f "$author_script" ||
 189                get_author_ident_from_commit "$1" > "$author_script"
 190}
 191
 192die_with_patch () {
 193        echo "$1" > "$state_dir"/stopped-sha
 194        make_patch "$1"
 195        git rerere
 196        die "$2"
 197}
 198
 199exit_with_patch () {
 200        echo "$1" > "$state_dir"/stopped-sha
 201        make_patch $1
 202        git rev-parse --verify HEAD > "$amend"
 203        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 204        warn "You can amend the commit now, with"
 205        warn
 206        warn "  git commit --amend $gpg_sign_opt_quoted"
 207        warn
 208        warn "Once you are satisfied with your changes, run"
 209        warn
 210        warn "  git rebase --continue"
 211        warn
 212        exit $2
 213}
 214
 215die_abort () {
 216        rm -rf "$state_dir"
 217        die "$1"
 218}
 219
 220has_action () {
 221        test -n "$(git stripspace --strip-comments <"$1")"
 222}
 223
 224is_empty_commit() {
 225        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
 226                die "$1: not a commit that can be picked")
 227        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
 228                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
 229        test "$tree" = "$ptree"
 230}
 231
 232is_merge_commit()
 233{
 234        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 235}
 236
 237# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 238# GIT_AUTHOR_DATE exported from the current environment.
 239do_with_author () {
 240        (
 241                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 242                "$@"
 243        )
 244}
 245
 246git_sequence_editor () {
 247        if test -z "$GIT_SEQUENCE_EDITOR"
 248        then
 249                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 250                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 251                then
 252                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 253                fi
 254        fi
 255
 256        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 257}
 258
 259pick_one () {
 260        ff=--ff
 261
 262        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 263        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 264        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 265
 266        if is_empty_commit "$sha1"
 267        then
 268                empty_args="--allow-empty"
 269        fi
 270
 271        test -d "$rewritten" &&
 272                pick_one_preserving_merges "$@" && return
 273        output eval git cherry-pick \
 274                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 275                        "$strategy_args" $empty_args $ff "$@"
 276
 277        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 278        # previous task so this commit is not lost.
 279        ret=$?
 280        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 281        return $ret
 282}
 283
 284pick_one_preserving_merges () {
 285        fast_forward=t
 286        case "$1" in
 287        -n)
 288                fast_forward=f
 289                sha1=$2
 290                ;;
 291        *)
 292                sha1=$1
 293                ;;
 294        esac
 295        sha1=$(git rev-parse $sha1)
 296
 297        if test -f "$state_dir"/current-commit
 298        then
 299                if test "$fast_forward" = t
 300                then
 301                        while read current_commit
 302                        do
 303                                git rev-parse HEAD > "$rewritten"/$current_commit
 304                        done <"$state_dir"/current-commit
 305                        rm "$state_dir"/current-commit ||
 306                        die "Cannot write current commit's replacement sha1"
 307                fi
 308        fi
 309
 310        echo $sha1 >> "$state_dir"/current-commit
 311
 312        # rewrite parents; if none were rewritten, we can fast-forward.
 313        new_parents=
 314        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 315        if test "$pend" = " "
 316        then
 317                pend=" root"
 318        fi
 319        while [ "$pend" != "" ]
 320        do
 321                p=$(expr "$pend" : ' \([^ ]*\)')
 322                pend="${pend# $p}"
 323
 324                if test -f "$rewritten"/$p
 325                then
 326                        new_p=$(cat "$rewritten"/$p)
 327
 328                        # If the todo reordered commits, and our parent is marked for
 329                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 330                        # drop it on top of the current HEAD
 331                        if test -z "$new_p"
 332                        then
 333                                new_p=$(git rev-parse HEAD)
 334                        fi
 335
 336                        test $p != $new_p && fast_forward=f
 337                        case "$new_parents" in
 338                        *$new_p*)
 339                                ;; # do nothing; that parent is already there
 340                        *)
 341                                new_parents="$new_parents $new_p"
 342                                ;;
 343                        esac
 344                else
 345                        if test -f "$dropped"/$p
 346                        then
 347                                fast_forward=f
 348                                replacement="$(cat "$dropped"/$p)"
 349                                test -z "$replacement" && replacement=root
 350                                pend=" $replacement$pend"
 351                        else
 352                                new_parents="$new_parents $p"
 353                        fi
 354                fi
 355        done
 356        case $fast_forward in
 357        t)
 358                output warn "Fast-forward to $sha1"
 359                output git reset --hard $sha1 ||
 360                        die "Cannot fast-forward to $sha1"
 361                ;;
 362        f)
 363                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 364
 365                if [ "$1" != "-n" ]
 366                then
 367                        # detach HEAD to current parent
 368                        output git checkout $first_parent 2> /dev/null ||
 369                                die "Cannot move HEAD to $first_parent"
 370                fi
 371
 372                case "$new_parents" in
 373                ' '*' '*)
 374                        test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 375
 376                        # redo merge
 377                        author_script_content=$(get_author_ident_from_commit $sha1)
 378                        eval "$author_script_content"
 379                        msg_content="$(commit_message $sha1)"
 380                        # No point in merging the first parent, that's HEAD
 381                        new_parents=${new_parents# $first_parent}
 382                        merge_args="--no-log --no-ff"
 383                        if ! do_with_author output eval \
 384                        'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
 385                                $merge_args $strategy_args -m "$msg_content" $new_parents'
 386                        then
 387                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 388                                die_with_patch $sha1 "Error redoing merge $sha1"
 389                        fi
 390                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 391                        ;;
 392                *)
 393                        output eval git cherry-pick \
 394                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 395                                "$strategy_args" "$@" ||
 396                                die_with_patch $sha1 "Could not pick $sha1"
 397                        ;;
 398                esac
 399                ;;
 400        esac
 401}
 402
 403nth_string () {
 404        case "$1" in
 405        *1[0-9]|*[04-9]) echo "$1"th;;
 406        *1) echo "$1"st;;
 407        *2) echo "$1"nd;;
 408        *3) echo "$1"rd;;
 409        esac
 410}
 411
 412update_squash_messages () {
 413        if test -f "$squash_msg"; then
 414                mv "$squash_msg" "$squash_msg".bak || exit
 415                count=$(($(sed -n \
 416                        -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
 417                        -e "q" < "$squash_msg".bak)+1))
 418                {
 419                        printf '%s\n' "$comment_char This is a combination of $count commits."
 420                        sed -e 1d -e '2,/^./{
 421                                /^$/d
 422                        }' <"$squash_msg".bak
 423                } >"$squash_msg"
 424        else
 425                commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
 426                count=2
 427                {
 428                        printf '%s\n' "$comment_char This is a combination of 2 commits."
 429                        printf '%s\n' "$comment_char The first commit's message is:"
 430                        echo
 431                        cat "$fixup_msg"
 432                } >"$squash_msg"
 433        fi
 434        case $1 in
 435        squash)
 436                rm -f "$fixup_msg"
 437                echo
 438                printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
 439                echo
 440                commit_message $2
 441                ;;
 442        fixup)
 443                echo
 444                printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
 445                echo
 446                # Change the space after the comment character to TAB:
 447                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 448                ;;
 449        esac >>"$squash_msg"
 450}
 451
 452peek_next_command () {
 453        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 454}
 455
 456# A squash/fixup has failed.  Prepare the long version of the squash
 457# commit message, then die_with_patch.  This code path requires the
 458# user to edit the combined commit message for all commits that have
 459# been squashed/fixedup so far.  So also erase the old squash
 460# messages, effectively causing the combined commit to be used as the
 461# new basis for any further squash/fixups.  Args: sha1 rest
 462die_failed_squash() {
 463        mv "$squash_msg" "$msg" || exit
 464        rm -f "$fixup_msg"
 465        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 466        warn
 467        warn "Could not apply $1... $2"
 468        die_with_patch $1 ""
 469}
 470
 471flush_rewritten_pending() {
 472        test -s "$rewritten_pending" || return
 473        newsha1="$(git rev-parse HEAD^0)"
 474        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 475        rm -f "$rewritten_pending"
 476}
 477
 478record_in_rewritten() {
 479        oldsha1="$(git rev-parse $1)"
 480        echo "$oldsha1" >> "$rewritten_pending"
 481
 482        case "$(peek_next_command)" in
 483        squash|s|fixup|f)
 484                ;;
 485        *)
 486                flush_rewritten_pending
 487                ;;
 488        esac
 489}
 490
 491do_pick () {
 492        if test "$(git rev-parse HEAD)" = "$squash_onto"
 493        then
 494                # Set the correct commit message and author info on the
 495                # sentinel root before cherry-picking the original changes
 496                # without committing (-n).  Finally, update the sentinel again
 497                # to include these changes.  If the cherry-pick results in a
 498                # conflict, this means our behaviour is similar to a standard
 499                # failed cherry-pick during rebase, with a dirty index to
 500                # resolve before manually running git commit --amend then git
 501                # rebase --continue.
 502                git commit --allow-empty --allow-empty-message --amend \
 503                           --no-post-rewrite -n -q -C $1 &&
 504                        pick_one -n $1 &&
 505                        git commit --allow-empty --allow-empty-message \
 506                                   --amend --no-post-rewrite -n -q -C $1 \
 507                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 508                        die_with_patch $1 "Could not apply $1... $2"
 509        else
 510                pick_one $1 ||
 511                        die_with_patch $1 "Could not apply $1... $2"
 512        fi
 513}
 514
 515do_next () {
 516        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 517        read -r command sha1 rest < "$todo"
 518        case "$command" in
 519        "$comment_char"*|''|noop|drop|d)
 520                mark_action_done
 521                ;;
 522        "$cr")
 523                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 524                mark_action_done
 525                ;;
 526        pick|p)
 527                comment_for_reflog pick
 528
 529                mark_action_done
 530                do_pick $sha1 "$rest"
 531                record_in_rewritten $sha1
 532                ;;
 533        reword|r)
 534                comment_for_reflog reword
 535
 536                mark_action_done
 537                do_pick $sha1 "$rest"
 538                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 539                        warn "Could not amend commit after successfully picking $sha1... $rest"
 540                        warn "This is most likely due to an empty commit message, or the pre-commit hook"
 541                        warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
 542                        warn "you are able to reword the commit."
 543                        exit_with_patch $sha1 1
 544                }
 545                record_in_rewritten $sha1
 546                ;;
 547        edit|e)
 548                comment_for_reflog edit
 549
 550                mark_action_done
 551                do_pick $sha1 "$rest"
 552                warn "Stopped at $sha1... $rest"
 553                exit_with_patch $sha1 0
 554                ;;
 555        squash|s|fixup|f)
 556                case "$command" in
 557                squash|s)
 558                        squash_style=squash
 559                        ;;
 560                fixup|f)
 561                        squash_style=fixup
 562                        ;;
 563                esac
 564                comment_for_reflog $squash_style
 565
 566                test -f "$done" && has_action "$done" ||
 567                        die "Cannot '$squash_style' without a previous commit"
 568
 569                mark_action_done
 570                update_squash_messages $squash_style $sha1
 571                author_script_content=$(get_author_ident_from_commit HEAD)
 572                echo "$author_script_content" > "$author_script"
 573                eval "$author_script_content"
 574                if ! pick_one -n $sha1
 575                then
 576                        git rev-parse --verify HEAD >"$amend"
 577                        die_failed_squash $sha1 "$rest"
 578                fi
 579                case "$(peek_next_command)" in
 580                squash|s|fixup|f)
 581                        # This is an intermediate commit; its message will only be
 582                        # used in case of trouble.  So use the long version:
 583                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 584                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 585                                die_failed_squash $sha1 "$rest"
 586                        ;;
 587                *)
 588                        # This is the final command of this squash/fixup group
 589                        if test -f "$fixup_msg"
 590                        then
 591                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 592                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 593                                        die_failed_squash $sha1 "$rest"
 594                        else
 595                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 596                                rm -f "$GIT_DIR"/MERGE_MSG
 597                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 598                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 599                                        die_failed_squash $sha1 "$rest"
 600                        fi
 601                        rm -f "$squash_msg" "$fixup_msg"
 602                        ;;
 603                esac
 604                record_in_rewritten $sha1
 605                ;;
 606        x|"exec")
 607                read -r command rest < "$todo"
 608                mark_action_done
 609                printf 'Executing: %s\n' "$rest"
 610                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 611                status=$?
 612                # Run in subshell because require_clean_work_tree can die.
 613                dirty=f
 614                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 615                if test "$status" -ne 0
 616                then
 617                        warn "Execution failed: $rest"
 618                        test "$dirty" = f ||
 619                        warn "and made changes to the index and/or the working tree"
 620
 621                        warn "You can fix the problem, and then run"
 622                        warn
 623                        warn "  git rebase --continue"
 624                        warn
 625                        if test $status -eq 127         # command not found
 626                        then
 627                                status=1
 628                        fi
 629                        exit "$status"
 630                elif test "$dirty" = t
 631                then
 632                        warn "Execution succeeded: $rest"
 633                        warn "but left changes to the index and/or the working tree"
 634                        warn "Commit or stash your changes, and then run"
 635                        warn
 636                        warn "  git rebase --continue"
 637                        warn
 638                        exit 1
 639                fi
 640                ;;
 641        *)
 642                warn "Unknown command: $command $sha1 $rest"
 643                fixtodo="Please fix this using 'git rebase --edit-todo'."
 644                if git rev-parse --verify -q "$sha1" >/dev/null
 645                then
 646                        die_with_patch $sha1 "$fixtodo"
 647                else
 648                        die "$fixtodo"
 649                fi
 650                ;;
 651        esac
 652        test -s "$todo" && return
 653
 654        comment_for_reflog finish &&
 655        newhead=$(git rev-parse HEAD) &&
 656        case $head_name in
 657        refs/*)
 658                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 659                git update-ref -m "$message" $head_name $newhead $orig_head &&
 660                git symbolic-ref \
 661                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 662                  HEAD $head_name
 663                ;;
 664        esac && {
 665                test ! -f "$state_dir"/verbose ||
 666                        git diff-tree --stat $orig_head..HEAD
 667        } &&
 668        {
 669                test -s "$rewritten_list" &&
 670                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 671                true # we don't care if this copying failed
 672        } &&
 673        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 674        if test -x "$hook" && test -s "$rewritten_list"; then
 675                "$hook" rebase < "$rewritten_list"
 676                true # we don't care if this hook failed
 677        fi &&
 678        warn "Successfully rebased and updated $head_name."
 679
 680        return 1 # not failure; just to break the do_rest loop
 681}
 682
 683# can only return 0, when the infinite loop breaks
 684do_rest () {
 685        while :
 686        do
 687                do_next || break
 688        done
 689}
 690
 691# skip picking commits whose parents are unchanged
 692skip_unnecessary_picks () {
 693        fd=3
 694        while read -r command rest
 695        do
 696                # fd=3 means we skip the command
 697                case "$fd,$command" in
 698                3,pick|3,p)
 699                        # pick a commit whose parent is current $onto -> skip
 700                        sha1=${rest%% *}
 701                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 702                        "$onto"*)
 703                                onto=$sha1
 704                                ;;
 705                        *)
 706                                fd=1
 707                                ;;
 708                        esac
 709                        ;;
 710                3,"$comment_char"*|3,)
 711                        # copy comments
 712                        ;;
 713                *)
 714                        fd=1
 715                        ;;
 716                esac
 717                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 718        done <"$todo" >"$todo.new" 3>>"$done" &&
 719        mv -f "$todo".new "$todo" &&
 720        case "$(peek_next_command)" in
 721        squash|s|fixup|f)
 722                record_in_rewritten "$onto"
 723                ;;
 724        esac ||
 725        die "Could not skip unnecessary pick commands"
 726}
 727
 728transform_todo_ids () {
 729        while read -r command rest
 730        do
 731                case "$command" in
 732                "$comment_char"* | exec)
 733                        # Be careful for oddball commands like 'exec'
 734                        # that do not have a SHA-1 at the beginning of $rest.
 735                        ;;
 736                *)
 737                        sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[     ]*}) &&
 738                        rest="$sha1 ${rest#*[    ]}"
 739                        ;;
 740                esac
 741                printf '%s\n' "$command${rest:+ }$rest"
 742        done <"$todo" >"$todo.new" &&
 743        mv -f "$todo.new" "$todo"
 744}
 745
 746expand_todo_ids() {
 747        transform_todo_ids
 748}
 749
 750collapse_todo_ids() {
 751        transform_todo_ids --short
 752}
 753
 754# Rearrange the todo list that has both "pick sha1 msg" and
 755# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 756# comes immediately after the former, and change "pick" to
 757# "fixup"/"squash".
 758#
 759# Note that if the config has specified a custom instruction format
 760# each log message will be re-retrieved in order to normalize the
 761# autosquash arrangement
 762rearrange_squash () {
 763        # extract fixup!/squash! lines and resolve any referenced sha1's
 764        while read -r pick sha1 message
 765        do
 766                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 767                case "$message" in
 768                "squash! "*|"fixup! "*)
 769                        action="${message%%!*}"
 770                        rest=$message
 771                        prefix=
 772                        # skip all squash! or fixup! (but save for later)
 773                        while :
 774                        do
 775                                case "$rest" in
 776                                "squash! "*|"fixup! "*)
 777                                        prefix="$prefix${rest%%!*},"
 778                                        rest="${rest#*! }"
 779                                        ;;
 780                                *)
 781                                        break
 782                                        ;;
 783                                esac
 784                        done
 785                        printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
 786                        # if it's a single word, try to resolve to a full sha1 and
 787                        # emit a second copy. This allows us to match on both message
 788                        # and on sha1 prefix
 789                        if test "${rest#* }" = "$rest"; then
 790                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 791                                if test -n "$fullsha"; then
 792                                        # prefix the action to uniquely identify this line as
 793                                        # intended for full sha1 match
 794                                        echo "$sha1 +$action $prefix $fullsha"
 795                                fi
 796                        fi
 797                esac
 798        done >"$1.sq" <"$1"
 799        test -s "$1.sq" || return
 800
 801        used=
 802        while read -r pick sha1 message
 803        do
 804                case " $used" in
 805                *" $sha1 "*) continue ;;
 806                esac
 807                printf '%s\n' "$pick $sha1 $message"
 808                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 809                used="$used$sha1 "
 810                while read -r squash action msg_prefix msg_content
 811                do
 812                        case " $used" in
 813                        *" $squash "*) continue ;;
 814                        esac
 815                        emit=0
 816                        case "$action" in
 817                        +*)
 818                                action="${action#+}"
 819                                # full sha1 prefix test
 820                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 821                        *)
 822                                # message prefix test
 823                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 824                        esac
 825                        if test $emit = 1; then
 826                                if test -n "${format}"
 827                                then
 828                                        msg_content=$(git log -n 1 --format="${format}" ${squash})
 829                                else
 830                                        msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
 831                                fi
 832                                printf '%s\n' "$action $squash $msg_content"
 833                                used="$used$squash "
 834                        fi
 835                done <"$1.sq"
 836        done >"$1.rearranged" <"$1"
 837        cat "$1.rearranged" >"$1"
 838        rm -f "$1.sq" "$1.rearranged"
 839}
 840
 841# Add commands after a pick or after a squash/fixup serie
 842# in the todo list.
 843add_exec_commands () {
 844        {
 845                first=t
 846                while read -r insn rest
 847                do
 848                        case $insn in
 849                        pick)
 850                                test -n "$first" ||
 851                                printf "%s" "$cmd"
 852                                ;;
 853                        esac
 854                        printf "%s %s\n" "$insn" "$rest"
 855                        first=
 856                done
 857                printf "%s" "$cmd"
 858        } <"$1" >"$1.new" &&
 859        mv "$1.new" "$1"
 860}
 861
 862# Check if the SHA-1 passed as an argument is a
 863# correct one, if not then print $2 in "$todo".badsha
 864# $1: the SHA-1 to test
 865# $2: the line number of the input
 866# $3: the input filename
 867check_commit_sha () {
 868        badsha=0
 869        if test -z $1
 870        then
 871                badsha=1
 872        else
 873                sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
 874                if test -z $sha1_verif
 875                then
 876                        badsha=1
 877                fi
 878        fi
 879
 880        if test $badsha -ne 0
 881        then
 882                line="$(sed -n -e "${2}p" "$3")"
 883                warn "Warning: the SHA-1 is missing or isn't" \
 884                        "a commit in the following line:"
 885                warn " - $line"
 886                warn
 887        fi
 888
 889        return $badsha
 890}
 891
 892# prints the bad commits and bad commands
 893# from the todolist in stdin
 894check_bad_cmd_and_sha () {
 895        retval=0
 896        lineno=0
 897        while read -r command rest
 898        do
 899                lineno=$(( $lineno + 1 ))
 900                case $command in
 901                "$comment_char"*|''|noop|x|exec)
 902                        # Doesn't expect a SHA-1
 903                        ;;
 904                "$cr")
 905                        # Work around CR left by "read" (e.g. with Git for
 906                        # Windows' Bash).
 907                        ;;
 908                pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
 909                        if ! check_commit_sha "${rest%%[        ]*}" "$lineno" "$1"
 910                        then
 911                                retval=1
 912                        fi
 913                        ;;
 914                *)
 915                        line="$(sed -n -e "${lineno}p" "$1")"
 916                        warn "Warning: the command isn't recognized" \
 917                                "in the following line:"
 918                        warn " - $line"
 919                        warn
 920                        retval=1
 921                        ;;
 922                esac
 923        done <"$1"
 924        return $retval
 925}
 926
 927# Print the list of the SHA-1 of the commits
 928# from stdin to stdout
 929todo_list_to_sha_list () {
 930        git stripspace --strip-comments |
 931        while read -r command sha1 rest
 932        do
 933                case $command in
 934                "$comment_char"*|''|noop|x|"exec")
 935                        ;;
 936                *)
 937                        long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
 938                        printf "%s\n" "$long_sha"
 939                        ;;
 940                esac
 941        done
 942}
 943
 944# Use warn for each line in stdin
 945warn_lines () {
 946        while read -r line
 947        do
 948                warn " - $line"
 949        done
 950}
 951
 952# Switch to the branch in $into and notify it in the reflog
 953checkout_onto () {
 954        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 955        output git checkout $onto || die_abort "could not detach HEAD"
 956        git update-ref ORIG_HEAD $orig_head
 957}
 958
 959get_missing_commit_check_level () {
 960        check_level=$(git config --get rebase.missingCommitsCheck)
 961        check_level=${check_level:-ignore}
 962        # Don't be case sensitive
 963        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 964}
 965
 966# Check if the user dropped some commits by mistake
 967# Behaviour determined by rebase.missingCommitsCheck.
 968# Check if there is an unrecognized command or a
 969# bad SHA-1 in a command.
 970check_todo_list () {
 971        raise_error=f
 972
 973        check_level=$(get_missing_commit_check_level)
 974
 975        case "$check_level" in
 976        warn|error)
 977                # Get the SHA-1 of the commits
 978                todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
 979                todo_list_to_sha_list <"$todo" >"$todo".newsha1
 980
 981                # Sort the SHA-1 and compare them
 982                sort -u "$todo".oldsha1 >"$todo".oldsha1+
 983                mv "$todo".oldsha1+ "$todo".oldsha1
 984                sort -u "$todo".newsha1 >"$todo".newsha1+
 985                mv "$todo".newsha1+ "$todo".newsha1
 986                comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
 987
 988                # Warn about missing commits
 989                if test -s "$todo".miss
 990                then
 991                        test "$check_level" = error && raise_error=t
 992
 993                        warn "Warning: some commits may have been dropped" \
 994                                "accidentally."
 995                        warn "Dropped commits (newer to older):"
 996
 997                        # Make the list user-friendly and display
 998                        opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
 999                        git rev-list $opt <"$todo".miss | warn_lines
1000
1001                        warn "To avoid this message, use \"drop\" to" \
1002                                "explicitly remove a commit."
1003                        warn
1004                        warn "Use 'git config rebase.missingCommitsCheck' to change" \
1005                                "the level of warnings."
1006                        warn "The possible behaviours are: ignore, warn, error."
1007                        warn
1008                fi
1009                ;;
1010        ignore)
1011                ;;
1012        *)
1013                warn "Unrecognized setting $check_level for option" \
1014                        "rebase.missingCommitsCheck. Ignoring."
1015                ;;
1016        esac
1017
1018        if ! check_bad_cmd_and_sha "$todo"
1019        then
1020                raise_error=t
1021        fi
1022
1023        if test $raise_error = t
1024        then
1025                # Checkout before the first commit of the
1026                # rebase: this way git rebase --continue
1027                # will work correctly as it expects HEAD to be
1028                # placed before the commit of the next action
1029                checkout_onto
1030
1031                warn "You can fix this with 'git rebase --edit-todo'."
1032                die "Or you can abort the rebase with 'git rebase --abort'."
1033        fi
1034}
1035
1036# The whole contents of this file is run by dot-sourcing it from
1037# inside a shell function.  It used to be that "return"s we see
1038# below were not inside any function, and expected to return
1039# to the function that dot-sourced us.
1040#
1041# However, FreeBSD /bin/sh misbehaves on such a construct and
1042# continues to run the statements that follow such a "return".
1043# As a work-around, we introduce an extra layer of a function
1044# here, and immediately call it after defining it.
1045git_rebase__interactive () {
1046
1047case "$action" in
1048continue)
1049        # do we have anything to commit?
1050        if git diff-index --cached --quiet HEAD --
1051        then
1052                # Nothing to commit -- skip this commit
1053
1054                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1055                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1056                die "Could not remove CHERRY_PICK_HEAD"
1057        else
1058                if ! test -f "$author_script"
1059                then
1060                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1061                        die "You have staged changes in your working tree. If these changes are meant to be
1062squashed into the previous commit, run:
1063
1064  git commit --amend $gpg_sign_opt_quoted
1065
1066If they are meant to go into a new commit, run:
1067
1068  git commit $gpg_sign_opt_quoted
1069
1070In both case, once you're done, continue with:
1071
1072  git rebase --continue
1073"
1074                fi
1075                . "$author_script" ||
1076                        die "Error trying to find the author identity to amend commit"
1077                if test -f "$amend"
1078                then
1079                        current_head=$(git rev-parse --verify HEAD)
1080                        test "$current_head" = $(cat "$amend") ||
1081                        die "\
1082You have uncommitted changes in your working tree. Please, commit them
1083first and then run 'git rebase --continue' again."
1084                        do_with_author git commit --amend --no-verify -F "$msg" -e \
1085                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1086                                die "Could not commit staged changes."
1087                else
1088                        do_with_author git commit --no-verify -F "$msg" -e \
1089                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1090                                die "Could not commit staged changes."
1091                fi
1092        fi
1093
1094        if test -r "$state_dir"/stopped-sha
1095        then
1096                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1097        fi
1098
1099        require_clean_work_tree "rebase"
1100        do_rest
1101        return 0
1102        ;;
1103skip)
1104        git rerere clear
1105
1106        do_rest
1107        return 0
1108        ;;
1109edit-todo)
1110        git stripspace --strip-comments <"$todo" >"$todo".new
1111        mv -f "$todo".new "$todo"
1112        collapse_todo_ids
1113        append_todo_help
1114        git stripspace --comment-lines >>"$todo" <<\EOF
1115
1116You are editing the todo file of an ongoing interactive rebase.
1117To continue rebase after editing, run:
1118    git rebase --continue
1119
1120EOF
1121
1122        git_sequence_editor "$todo" ||
1123                die "Could not execute editor"
1124        expand_todo_ids
1125
1126        exit
1127        ;;
1128esac
1129
1130git var GIT_COMMITTER_IDENT >/dev/null ||
1131        die "You need to set your committer info first"
1132
1133comment_for_reflog start
1134
1135if test ! -z "$switch_to"
1136then
1137        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1138        output git checkout "$switch_to" -- ||
1139        die "Could not checkout $switch_to"
1140
1141        comment_for_reflog start
1142fi
1143
1144orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
1145mkdir -p "$state_dir" || die "Could not create temporary $state_dir"
1146
1147: > "$state_dir"/interactive || die "Could not mark as interactive"
1148write_basic_state
1149if test t = "$preserve_merges"
1150then
1151        if test -z "$rebase_root"
1152        then
1153                mkdir "$rewritten" &&
1154                for c in $(git merge-base --all $orig_head $upstream)
1155                do
1156                        echo $onto > "$rewritten"/$c ||
1157                                die "Could not init rewritten commits"
1158                done
1159        else
1160                mkdir "$rewritten" &&
1161                echo $onto > "$rewritten"/root ||
1162                        die "Could not init rewritten commits"
1163        fi
1164        # No cherry-pick because our first pass is to determine
1165        # parents to rewrite and skipping dropped commits would
1166        # prematurely end our probe
1167        merges_option=
1168else
1169        merges_option="--no-merges --cherry-pick"
1170fi
1171
1172shorthead=$(git rev-parse --short $orig_head)
1173shortonto=$(git rev-parse --short $onto)
1174if test -z "$rebase_root"
1175        # this is now equivalent to ! -z "$upstream"
1176then
1177        shortupstream=$(git rev-parse --short $upstream)
1178        revisions=$upstream...$orig_head
1179        shortrevisions=$shortupstream..$shorthead
1180else
1181        revisions=$onto...$orig_head
1182        shortrevisions=$shorthead
1183fi
1184format=$(git config --get rebase.instructionFormat)
1185# the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1186git rev-list $merges_option --format="%m%H ${format:-%s}" \
1187        --reverse --left-right --topo-order \
1188        $revisions ${restrict_revision+^$restrict_revision} | \
1189        sed -n "s/^>//p" |
1190while read -r sha1 rest
1191do
1192
1193        if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1194        then
1195                comment_out="$comment_char "
1196        else
1197                comment_out=
1198        fi
1199
1200        if test t != "$preserve_merges"
1201        then
1202                printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1203        else
1204                if test -z "$rebase_root"
1205                then
1206                        preserve=t
1207                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1208                        do
1209                                if test -f "$rewritten"/$p
1210                                then
1211                                        preserve=f
1212                                fi
1213                        done
1214                else
1215                        preserve=f
1216                fi
1217                if test f = "$preserve"
1218                then
1219                        touch "$rewritten"/$sha1
1220                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1221                fi
1222        fi
1223done
1224
1225# Watch for commits that been dropped by --cherry-pick
1226if test t = "$preserve_merges"
1227then
1228        mkdir "$dropped"
1229        # Save all non-cherry-picked changes
1230        git rev-list $revisions --left-right --cherry-pick | \
1231                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1232        # Now all commits and note which ones are missing in
1233        # not-cherry-picks and hence being dropped
1234        git rev-list $revisions |
1235        while read rev
1236        do
1237                if test -f "$rewritten"/$rev &&
1238                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1239                then
1240                        # Use -f2 because if rev-list is telling us this commit is
1241                        # not worthwhile, we don't want to track its multiple heads,
1242                        # just the history of its first-parent for others that will
1243                        # be rebasing on top of it
1244                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1245                        sha1=$(git rev-list -1 $rev)
1246                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1247                        rm "$rewritten"/$rev
1248                fi
1249        done
1250fi
1251
1252test -s "$todo" || echo noop >> "$todo"
1253test -n "$autosquash" && rearrange_squash "$todo"
1254test -n "$cmd" && add_exec_commands "$todo"
1255
1256todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1257todocount=${todocount##* }
1258
1259cat >>"$todo" <<EOF
1260
1261$comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
1262EOF
1263append_todo_help
1264git stripspace --comment-lines >>"$todo" <<\EOF
1265
1266However, if you remove everything, the rebase will be aborted.
1267
1268EOF
1269
1270if test -z "$keep_empty"
1271then
1272        printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
1273fi
1274
1275
1276has_action "$todo" ||
1277        return 2
1278
1279cp "$todo" "$todo".backup
1280collapse_todo_ids
1281git_sequence_editor "$todo" ||
1282        die_abort "Could not execute editor"
1283
1284has_action "$todo" ||
1285        return 2
1286
1287check_todo_list
1288
1289expand_todo_ids
1290
1291test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1292
1293checkout_onto
1294do_rest
1295
1296}
1297# ... and then we call the whole thing.
1298git_rebase__interactive